/* EvgRedirect */
/* main.cpp */
#define POKA 0

#define INCL_DOS
#define  INCL_BASE
#include <os2.h>

#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <signal.h>

 #include <types.h>
 #include <sys\socket.h>
 #include <netinet\in.h>
 #include <netnb\nb.h>
 #include <sys\un.h>

#include "getopt.h"

#include "sg.h"
#include "SQDRclient.hpp"

#define VERSION "0.03"
//८筮 ஢ન 䨣    ᥪ㭤
#define CHECK_CONFIG_TIME  60

/* Internal functions prototypes */
void usage(void);
int sgReadConfig(char *confname);
int sgCheckForReloadConfig(char *fname,int checktime);
char * sg_fgets(char *buf, int buflen, int fd);
int sg_puts(char *buf, int fd);

int _Optlink RedirSortCmp(const void* s1, const void* s2);
int ReDir_SortIndex(void);
int SendQueryToServer(char *qurl, char *bufout,int bufoutlen);



struct LogFileStat *globalErrorLog = NULL;
struct LogFile *globalLogFile = NULL;

struct LogFileStat *lastLogFileStat;
struct LogFileStat *LogFileStat;


char **globalArgv ;
char **globalEnvp ;
int globalDebugTimeDelta = 0;
int globalDebug = 0;
int globalPid = 0;
int globalUpdate = 0;
char *globalCreateDb = NULL;
int failsafe_mode = 0;
int sig_hup = 0;
int sig_alrm = 0;
int sgtime = 0;
char *globalLogDir = NULL;
int sockSquid= -1;
static const char *hello_string = "hi there\n";
char *progname;

char *configFile = "SQDR/redir.rules";
char *cWord_BaseRedirUrl = "BaseRedirUrl";
char *cWord_DefaultRedir = "DefaultRedir";
char *cWord_RedirRules   = "RedirRules";
char const  *sg_strhttp="http://", *sg_strwww="www.";


#define MAX_REDIR_TABLE     1024
#define MAX_URL_BUFF        102400
#define MAX_REDIR_URL_BUFF   51200



struct Eredir2
{  char *url;
   char *redirurl;
   int line;   // 室 ப 㫥ᮢ
   int type;   // ⨯ 㫥ᮢ: 0 - ࠢ  砫, 1 - ப, 2 - ࠢ  
   int section;// ᥪ樨 (/稪//୮/䠩)
};

struct ReDir
{
   int  Nredir;     //  redir2
   int  Nredir_any; //  redir_any
   int  Nredir_end; //  redir_end
   int  NredirUrls; //  pRedirUrl
   int  L_UrlBuff;
   int  L_RedirUrl;
   FILE *fplog;     // fp -䠩

   char BaseRedirUrl[512];
   char DefaultRedir[512];
   struct Eredir2 redir2[MAX_REDIR_TABLE];    // ⠡ ૮   砫
   struct Eredir2 redir_end[MAX_REDIR_TABLE]; // ⠡ ૮   殬 ($)
   struct Eredir2 redir_any[MAX_REDIR_TABLE]; // ⠡ ப ૮

   char UrlBuff[MAX_URL_BUFF];
   char RedirUrlBuff[MAX_REDIR_URL_BUFF];
   char *pRedirUrl[MAX_REDIR_TABLE];

};

struct ReDir rd={0,0,0,0,0,NULL};



// ७ ?
struct timeval
{
  long tv_sec;
  long tv_usec;
};

class NPipe SQDRpipe;

int main(int argc, char *argv[], char *envp[])
{
  int ch,i,rep;
static   struct SquidInfo squidInfo;
  struct Source *src;
  struct timeval start_time,ready_time,stop_time;
static  char buf[MAX_BUF],lastquery[MAX_BUF]="",bufout[MAX_BUF];
  char *redirect;
  time_t t;
      int fd=-1;
      int rc, t0,t01;

  squidInfo.protocol[0] = 0;

  progname = argv[0];

  globalArgv = argv;
  globalEnvp = envp;

  sgSetGlobalErrorLogFile();
  sgReadConfig(configFile);
  sgCheckForReloadConfig(configFile,0);

  sgSetGlobalErrorLogFile();
  sgLogError("squidGuard %s started", VERSION);

/* 室 宭  -ࢥ୮-  */
/* ᪠ ࢥ - ᫨  㦥 饭 - ᠬ 뢠 */

  system("start /N sqdrserver");
//  system("start sqdrserver");
  DosSleep(200);
   for(rep=0,i=0;i<MAX_NUM_PIPES,rep<40+MAX_NUM_PIPES;i++)
   {  if(i) sprintf(buf,"%s%i",SQDR_BASE_PIPE_NAME,i);
      else strcpy(buf,SQDR_BASE_PIPE_NAME);

      SQDRpipe = NPipe(buf,CLIENT_MODE);

      rc = SQDRpipe.Open();
      if(rc == ERROR_PIPE_BUSY)
               continue;
      if(rc == ERROR_PATH_NOT_FOUND)
      {  rep++;
         DosSleep(100+rep*10);
         i--;
         if(rep == MAX_NUM_PIPES) i = -1;
         continue;
      }
      if(rc)
      {  printf("訡 p  rc=%i",rc);
         sgLogError("訡 p  rc=%i, Exitting",rc);
         if(rc == ERROR_INVALID_PARAMETER) printf("(H⨬ pp");
         exit(1);
      }
      break;
    }
    if(!SQDRpipe.Hpipe)
    {  printf("Can't open pipe(s)");
       sgLogError("Can't open pipe(s), Exitting");
       exit(2);
    }
    printf("Open pipe=%i\n",rc);
    rc = SQDRpipe.HandShake();
    printf("HandShake=%i\n",rc);
    if(rc ==  HAND_SHAKE_ERROR)
    {
        printf("訡 handshake\n",rc);
        sgLogError("訡 handshake  pipe, Exitting");
        exit(1);
    }

/************************/

//  for(i=0;i<argc;i++)
//  {
//    sgLogError("argv[%i] = %s",i,argv[i]);
//  }

  sock_init();

/*********************** ࠧ  ப *****************/
   while ((ch = getopt(argc, argv, "hduC:t:c:vs:p:")) != EOF)
    switch (ch) {
    case 'd':
       globalDebug = 1;
      break;
    case 'c':
      configFile = optarg;
      break;
//    case 'p':
//         globalPid = atoi(optarg) - 6;
//         printf("globalPid=%i",globalPid);
//      break;
    case 's' :
      sscanf(optarg,"%i -p %i", &sockSquid,&globalPid);
//      printf("S optarg =%s",optarg);
//      printf(" sockSquid=%i, globalPid=%i",sockSquid,globalPid);
      globalPid -= 6;
      sockSquid = atoi(optarg);
            if (sockSquid < 0)
            {  printf("squidGuard: unable to import socket handle\n");
               sgLogError("unable to import socket handle %x (optarg=%s)",sockSquid,optarg);
              exit(1);
            }
       sgLogError("socket handle %x (optarg=%s)",sockSquid,optarg);
      break;
    case '?':
    case 'h':
    default:
      usage();
    }
/**********************************************/

    if (sockSquid >= 0)
    {
      fd = accept(sockSquid, NULL, NULL);
      if (fd < 0)
      {  rc = sock_errno();
         psock_errno(NULL);
         printf("redirector: unable to accept socket handle, rc =%i\n",rc);
        sgLogError("redirector: unable to accept socket handle,rc=%i \n",rc);
        exit(1);
      }
/*********************************************/
      rc = send(fd, hello_string, strlen(hello_string), 0);
/*********************************************/
       if (rc !=  strlen(hello_string) )
      {
            psock_errno(NULL);
           printf ("ipcCreate: CHILD: hello write test failed, rc = %i\n",rc);
           sgLogError("ipcCreate: CHILD: hello write test failed (rc=%i)\n",rc);
       _exit(1);
      }
        else printf("Redirector (SQDR)\t\t:OK\n");

     sgLogError("Redirector (SQDR)\t\t:OK fd=%i\n",fd);
    }

  sprintf(buf,"SQDR/redir%i.log",globalPid);

  rd.fplog= fopen(buf,"a");


  while(1)
  {  char *pbuf;
     t0 = clock();
//    while(fgets(buf, MAX_BUF, stdin) != NULL)
     while( sg_fgets(buf, MAX_BUF, fd) != NULL)

    {
       i = strlen(buf);
       if(buf[i-1] == '\n') buf[i-1] = 0;
       t01 = clock();
       if(abs(t0-t01) > 1000 || strcmp(buf,lastquery)) /* speed up fast and repiated queryes without any server query */
       {   strcpy(lastquery,buf);
           rc = SendQueryToServer(buf, bufout,sizeof(bufout));
           if(rc)
           {   sgLogError("sqdr pipe read error=%i",rc);
               break;
           }
       }
       sg_puts(bufout, fd);
    }

#if HAVE_SIGNAL
    if(errno != EINTR){
      gettimeofday(&stop_time, NULL);
      stop_time.tv_sec = stop_time.tv_sec + globalDebugTimeDelta;
      sgLogError("squidGuard stopped (%d.%03d)",stop_time.tv_sec,stop_time.tv_usec/1000);
      exit(2);
    }
#endif
    sgLogError("sqdr client stopped");
    fclose(rd.fplog);
    exit(0);
  }

      _fcloseall();
      close(sockSquid);
      dup2(fd, 1);
      dup2(fd, 0);
      close(fd);

  fclose(rd.fplog);
  exit(0);
}

void usage(void)
{
  fprintf(stderr,
         "Usage: squidGuard [-u] [-C block] [-t time] [-c file] [-v] [-d]\n");
  fprintf(stderr, "Options:\n");
  fprintf(stderr, "  -v          : show version number\n");
  fprintf(stderr, "  -d          : all errors to stderr\n");
  fprintf(stderr, "  -c file     : load alternate configfile\n");
  fprintf(stderr, "  -t time     : specify staruptime on format: yyyy-mm-ddTHH:MM:SS\n");
  fprintf(stderr, "  -u          : update .db files from .diff files\n");
  fprintf(stderr, "  -C file|all : create new .db files from urls/domain files\n");
  fprintf(stderr, "                specified in \"file\".\n");
  exit(1);
}


int Add_ReDir(char *url, char *redir, int nline);
int Add_ReDir_any(char *url, char *redir, int nline);
int Add_ReDir_end(char *url, char *redir, int nline);

/* ⠥ 䠩  㫥ᠬ */
int sgReadConfig(char *confname)
{   int i,j,l,is, is_section, nline,rc;
    FILE *fp;
static    char str[MAX_BUF], *pstr;
static    char strtmp[MAX_BUF], str1[MAX_BUF];

    fp = fopen(confname,"r");
    if(fp == NULL)
    {
       sgLogError("Can't read conf file %s",confname);
       exit(1);

    }
// base rules
    is_section = 0;
    nline = 0;
    while(fgets(str,MAX_BUF,fp))
    {  nline++;
       l = strlen(str);
       is = 0;
       for(i=0;i<l;i++)
       {  if(str[i] > 32)
          {  if(str[i] == '#' || str[i] == ';' ) is = 1;
             break;
          }
       }
       if(is)       /* it is comment */
          continue;
       pstr = strstr(str,cWord_BaseRedirUrl);
       if(pstr)
       {   pstr += strlen(cWord_BaseRedirUrl);
           pstr = strstr(pstr,"=");
           pstr++;
           sscanf( pstr,"%s",rd.BaseRedirUrl);
           is_section++;
       }
       pstr = strstr(str,cWord_DefaultRedir);
       if(pstr)
       {   pstr += strlen(cWord_DefaultRedir);
           pstr = strstr(pstr,"=");
           pstr++;
           sscanf( pstr,"%s",rd.DefaultRedir);
           is_section++;
       }
       pstr = strstr(str,cWord_RedirRules);
       if(pstr)
       {   is_section += 2;
           break;
       }

    }

    if(!is_section)
    {  sgLogError("Not found section %s in conf file %s",cWord_BaseRedirUrl,confname);
       exit(1);
    }
    if(is_section<2)
    {  sgLogError("Not found section %s in conf file %s",cWord_RedirRules,confname);
       exit(1);
    }

//redir rules
     rd.Nredir=0;
     rd.NredirUrls=0;
     rd.Nredir_any = 0;
     rd.Nredir_end = 0;
     rd.L_UrlBuff =0;
     rd.L_RedirUrl=0;

    is_section = 0;
    while(fgets(str,MAX_BUF,fp))
    {  nline++;
       l = strlen(str);
       if(l<=1)
           continue;
       is = 0;
       for(i=0;i<l;i++)
       {  if(str[i] > 32)
          {  if(str[i] == '#' || str[i] == ';' ) is = 1;
             break;
          }
       }
       if(is)       /* it is comment */
          continue;
       str1[0]=0;
       strtmp[0] = 0;
       rc = sscanf(str,"%s %s",strtmp, str1);
       if(rc <= 0)
             continue;
       if(strtmp[0])
       {  char c_strtmplast;
          c_strtmplast = strtmp[strlen(strtmp)-1];
          if(strtmp[0] == '*')  //   ப
          {
             if(str1[0])  Add_ReDir_any(strtmp, str1, nline);
              else        Add_ReDir_any(strtmp, rd.DefaultRedir,nline);
          } else if(c_strtmplast == '$') {     //    ૠ
             if(str1[0])  Add_ReDir_end(strtmp, str1, nline);
              else        Add_ReDir_end(strtmp, rd.DefaultRedir,nline);

          } else {              //   砫 ૠ
             if(str1[0])  Add_ReDir(strtmp, str1, nline);
              else        Add_ReDir(strtmp, rd.DefaultRedir,nline);
          }
       }

    }


    fclose(fp);

    ReDir_SortIndex();
    sgLogError("ReDir_SortIndex Nredir=%i,Nredir_any=%i,L_UrlBuff=%i,NredirUrls=%i,L_RedirUrl=%i",
               rd.Nredir,rd.Nredir_any,rd.L_UrlBuff,rd.NredirUrls,rd.L_RedirUrl);

    return 0;
}

int Add_ReDir_redirurl(struct ReDir *rd, char *redirurl, int mode)
{  int i,is,l1;
   is = 0;

   for(i=0;i <  rd->NredirUrls ;i++)
   {  if(!strcmp(rd->pRedirUrl[i],redirurl) )
      { is = 1;
        if(mode == 2)
        {  rd->redir_end[rd->Nredir_end].redirurl = rd->pRedirUrl[i];
        } else if(mode == 1) {
           rd->redir_any[rd->Nredir_any].redirurl = rd->pRedirUrl[i];
        } else {
           rd->redir2[rd->Nredir].redirurl = rd->pRedirUrl[i];
        }
        break;
      }
   }
   if(is) return 2;
   l1 = strlen(redirurl);
   memcpy(&rd->RedirUrlBuff[rd->L_RedirUrl],redirurl,l1+1);
   rd->pRedirUrl[rd->NredirUrls] = &rd->RedirUrlBuff[rd->L_RedirUrl];
   if(mode == 2)
   {  rd->redir_end[rd->Nredir_end].redirurl = rd->pRedirUrl[rd->NredirUrls];
   } else if(mode == 1) {
      rd->redir_any[rd->Nredir_any].redirurl = rd->pRedirUrl[rd->NredirUrls];
   } else {
      rd->redir2[rd->Nredir].redirurl = rd->pRedirUrl[rd->NredirUrls];
   }

   rd->NredirUrls++;
   rd->L_RedirUrl += l1 +1;
   return 1;
}

/*    ᯨ᮪ ᪠  砫 ૠ */
int Add_ReDir(char *url, char *redir, int nline)
{ int l0,l1;
  if(url == NULL || redir == NULL)
                       return 1;
    if(!strncmp(url,sg_strhttp, strlen(sg_strhttp)) ) // 㡨ࠥ http://
    {  url += strlen(sg_strhttp);
    }
    if(!strncmp(url,sg_strwww, strlen(sg_strwww)) )   //㡨ࠥ www.
    {  url += strlen(sg_strwww);
    }
 l0 = strlen(url);
  l1 = strlen(redir);
  if(rd.L_UrlBuff + l0 +1 >= MAX_URL_BUFF)
  {   printf("increase MAX_URL_BUFF\n");
      sgLogError("increase MAX_URL_BUFF");
      exit(1);
  }
  if(rd.L_RedirUrl + l1 +1 >= MAX_REDIR_URL_BUFF)
  {   printf("increase MAX_REDIR_URL_BUFF\n");
      sgLogError("increase MAX_REDIR_URL_BUFF");
      exit(1);
  }

  if(rd.Nredir+ 1 >= MAX_REDIR_URL_BUFF)
  {   printf("increase MAX_REDIR_TABLE\n");
      sgLogError("increase MAX_REDIR_TABLE");
      exit(1);
  }
  memcpy(&rd.UrlBuff[rd.L_UrlBuff],url,l0+1);
  rd.redir2[rd.Nredir].url = &rd.UrlBuff[rd.L_UrlBuff];
  rd.L_UrlBuff += l0 +1;
  rd.redir2[rd.Nredir].line = nline;
  rd.redir2[rd.Nredir].type = 0;
  Add_ReDir_redirurl(&rd, redir,0);
  rd.Nredir++;
  return 0;
}

/*    ᯨ᮪ ᪠   ૠ */
int Add_ReDir_end(char *url, char *redir, int nline)
{ int l0,l1,i;

  if(url == NULL || redir == NULL)
                       return 1;
  l0 = strlen(url);
  if(url[l0-1] == '$') l0--;
  l1 = strlen(redir);
  if(rd.L_UrlBuff + l0 +1 >= MAX_URL_BUFF)
  {   printf("increase MAX_URL_BUFF\n");
      sgLogError("increase MAX_URL_BUFF");
      exit(1);
  }
  if(rd.L_RedirUrl + l1 +1 >= MAX_REDIR_URL_BUFF)
  {   printf("increase MAX_REDIR_URL_BUFF\n");
      sgLogError("increase MAX_REDIR_URL_BUFF");
      exit(1);
  }

  if(rd.Nredir_end + 1 >= MAX_REDIR_URL_BUFF)
  {   printf("increase MAX_REDIR_TABLE (Nredir_end)\n");
      sgLogError("increase MAX_REDIR_TABLE (Nredir_end)");
      exit(1);
  }
  for(i=0;i<l0;i++)
  {  rd.UrlBuff[rd.L_UrlBuff+i] = url[l0-i-1];
  }
  rd.UrlBuff[rd.L_UrlBuff+l0] = 0;

  rd.redir_end[rd.Nredir_end].url = &rd.UrlBuff[rd.L_UrlBuff];
  rd.L_UrlBuff += l0 +1;
  rd.redir_end[rd.Nredir_end].line = nline;
  rd.redir_end[rd.Nredir].type = 2;
  Add_ReDir_redirurl(&rd, redir,2);
  rd.Nredir_end++;
  return 0;
}

/*    ᯨ᮪ ᪠  ப ૠ */
int Add_ReDir_any(char *url, char *redir, int nline)
{ int l0,l1;
  if(url == NULL || redir == NULL)
                       return 1;

  if(*url == '*') url++;

  l0 = strlen(url);
  l1 = strlen(redir);
  if(rd.L_UrlBuff + l0 +1 >= MAX_URL_BUFF)
  {   printf("increase MAX_URL_BUFF\n");
      sgLogError("increase MAX_URL_BUFF");
      exit(1);
  }
  if(rd.L_RedirUrl + l1 +1 >= MAX_REDIR_URL_BUFF)
  {   printf("increase MAX_REDIR_URL_BUFF\n");
      sgLogError("increase MAX_REDIR_URL_BUFF");
      exit(1);
  }

  if(rd.Nredir_any+ 1 >= MAX_REDIR_URL_BUFF)
  {   printf("increase MAX_REDIR_TABLE (for \"any\")\n");
      sgLogError("increase MAX_REDIR_TABLE (for \"any\")");
      exit(1);
  }
  memcpy(&rd.UrlBuff[rd.L_UrlBuff],url,l0+1);
  rd.redir_any[rd.Nredir_any].url = &rd.UrlBuff[rd.L_UrlBuff];
  rd.L_UrlBuff += l0 +1;
  rd.redir_any[rd.Nredir_any].line = nline;
  rd.redir_any[rd.Nredir].type = 1;
  Add_ReDir_redirurl(&rd, redir,1);
  rd.Nredir_any++;
 return 0;
}
/* ⥭ ப  ᮪ */
char * sg_fgets(char *buf, int buflen, int fd)
{  int rc;
  if(fd < 0)
       return  fgets(buf, buflen, stdin);
  rc = recv(fd,buf,buflen-1,0);

  if(rc > 0)
  {  buf[rc] = 0;
     return buf;
  }
  else
     return NULL;
}

int sg_puts(char *buf, int fd)
{  int rc;
static  char buff[MAX_BUF];
   if(fd < 0)
   {     puts(buf);
   } else {
      strcpy(buff,buf);
      strcat(buff,"\n");

      rc = send(fd, buff, strlen(buff), 0);
//  sgLogError("send( %x)=%i =>%s<",fd,rc,buff);
      return rc;
  }
  return 0;
}


/* 㭪 ࠢ struct Eredir2 */
int _Optlink RedirSortCmp(const void* s1, const void* s2)
{   struct Eredir2 * pvInd1, *pvInd2;
    int rc;

    pvInd1 =(struct Eredir2 *) s1;
    pvInd2 =(struct Eredir2 *) s2;
    rc = strcmp(pvInd1->url,pvInd2->url);
    return rc;
}
int ReDir_SortIndex(void)
{   int rc;
    qsort( (void *) rd.redir2,rd.Nredir, sizeof(struct Eredir2), RedirSortCmp);
    qsort( (void *) rd.redir_any,rd.Nredir_any, sizeof(struct Eredir2), RedirSortCmp);
    qsort( (void *) rd.redir_end,rd.Nredir_end, sizeof(struct Eredir2), RedirSortCmp);
    return 0;
}


/************************/
int SendQueryToServer(char *qurl, char *bufout,int bufoutlen)
{  int l,rc,ncmd,data;
   if(!qurl)
      return -1;
   l = strlen(qurl);
   if(!l)
      return -2;
   l++; //+ zero at end of string
   rc = SQDRpipe.SendCmdToServer(1,l); //  1 - ᫠   
   if(rc)
      return rc;
   rc = SQDRpipe.SendDataToServer((void *)qurl, l);
   if(rc)
      return rc;
   rc = SQDRpipe.RecvCmdFromClient(&ncmd,&data);
   if(rc)
      return rc;
   switch(ncmd)
   {  case 1:
        l = data;
        rc = SQDRpipe.RecvDataFromClient(bufout,&l,bufoutlen);
          break;

   }

   return rc;
}


